/*
 * This is the 1998 rewrite of IP Firewalling, aiming for kernel 2.3.x.
 *
 * Copyright (C) 1998 Paul F. Russell & Michael J. Neuling 
 *
 * This is an example module which is used for rejecting packets.
 * Simply sends back an icmp host unreachable and drops the packet
 *
*/

#include <linux/module.h> 
#include <linux/skbuff.h> 
#include <net/icmp.h> 
#include "ip_tables.h" 
#include "ip_tables_standard.h"

static int ipt_reject_action(struct sk_buff **skb, 
			     const char *indev,
			     const char *outdev,
			     void *info, 
			     unsigned int pos) 
{
    icmp_send(*skb, ICMP_DEST_UNREACH, ICMP_PORT_UNREACH, 0);
    return -NF_DROP - 1;
}

static int ipt_reject_checkentry(const void *info, 
				 unsigned int pos, 
				 unsigned int finalpos) 
{ 
    return 1; 
}



static struct ipt_action ipt_reject_reg 
= { NULL, "REJECT", ipt_reject_action, ipt_reject_checkentry, 
    &__this_module };

int init_module(void)
{
    if (ipt_register_function(&ipt_reject_reg))
	return -EINVAL;

    return 0;
}

void cleanup_module(void)
{
    ipt_unregister_function(&ipt_reject_reg);
}
