/* Module which passes packets indiscrimintately to userspace. */
#include <linux/module.h>
#include <linux/netfilter.h>

static unsigned int touserspace(unsigned int hooknum,
				struct sk_buff **skb,
				const struct device *in,
				const struct device *out)
{
	return NF_USERSPACE;
}

static int hook = -1;
MODULE_PARM(hook, "i");

static struct nf_hook_ops ops = { NULL, 0, touserspace, NULL, PF_INET, -1 };

int init_module(void)
{
	if (hook == -1) {
		printk("ip_usermod: Must specify hook=.\n");
		return -EINVAL;
	}

	ops.hooknum = hook;
	return nf_register_hook(&ops);
}

void cleanup_module(void)
{
	nf_unregister_hook(&ops);
}
