/* Simple netfilter thingy to pass packets. */
#include <sys/types.h>
#include <net/if.h>

typedef u_int32_t __u32;

#include <linux/netfilter_dev.h>
#include <linux/ip_netfilter.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

int main(int argc, const char *argv[])
{
	int fd;
	struct nfdev_ioctl ioc;
	struct nfdev_head head;
	char devicename[100];

	if (argc != 2) {
		fprintf(stderr, "Usage: %s [hook name]\n", argv[0]);
		return 1;
	}
	strcpy(devicename, "/dev/netfilter_ip_");
	strcat(devicename, argv[1]);

	fd = open(devicename, O_RDWR);
	if (fd < 0) {
		fprintf(stderr, "opening %s: %s\n", 
			devicename, strerror(errno));
		return 1;
	}

	while (read(fd, &head, sizeof(head)) == sizeof(head)) {
#if 0
		printf("in=%u/%s, out=%u/%s, mk=%u, len=%u\n",
		       head.inpid, head.iniface, head.outpid, head.outiface, 
		       head.nfmark, head.pktlen);
#endif
		ioc = ((struct nfdev_ioctl)
		       { NF_ACCEPT, head.pktlen, head.nfmark });
		if (ioctl(fd, NFDIOSVERDICT, &ioc) != 0) {
			fprintf(stderr, "ioctl: %s\n", strerror(errno));
			break;
		}
	}
	return 1;
}

	

